; verzija od 27.marta 2011, sa protokolom koji ima header char 101 i chs na kraju

  .include "p24fj64ga002.inc"

  .equ	gamma,6		; pazi gamma je samo 4, 5 ili 6
  .equ	maxcount,20000	; domet brojaca za PWM, mora da bude 20000

  .equiv led1p,LATB
  .equiv led1b,12
  .equiv led2p,LATB
  .equiv led2b,13
  .equiv led3p,LATB
  .equiv led3b,14
  .equiv led4p,LATB
  .equiv led4b,15

  .equiv dip1p,PORTB
  .equiv dip1b,5
  .equiv dip2p,PORTB
  .equiv dip2b,8 
  .equiv dip3p,PORTB
  .equiv dip3b,4 
  .equiv dip4p,PORTA
  .equiv dip4b,4

	config __CONFIG1,0b0010111001111111
	config __CONFIG2,0b0111101110100010

;------------------------------------------------------------------------------

.bss
JACINA:		.space 2	; GLOBAL value	0...100
CHS:		.space 2	; checksum
UNIFORM:	.space 2
INNER:		.space 2
OUTER:		.space 2

APPROACH1:	.space 2	; za polako priblizavanje jacini Y
APPROACH2:	.space 2	; za polako priblizavanje jacini R
APPROACH3:	.space 2	; za polako priblizavanje jacini G
APPROACH4:	.space 2	; za polako priblizavanje jacini B

TARGET1:	.space 2	; ciljna jacina Y
TARGET2:	.space 2	; ciljna jacina R
TARGET3:	.space 2	; ciljna jacina G
TARGET4:	.space 2	; ciljna jacina B
			; parametri koji su primljeni ali nije izvrsena chs kontrola
PREPWM1:	.space 2
PREPWM2:	.space 2
PREPWM3:	.space 2
PREPWM4:	.space 2
PREJACINA:	.space 2

PATIENCELO:	.space 2	; LO count za default vrednosti ako nema RX
PATIENCEHI:	.space 2	; HI count za default vrednosti ako nema RX

FLAG:		.space 2	; bit 0 set = prosao inicijalizaciju
				; bit 1 set = primio prvi paket
COUNT:		.space 2


;------------------------------------------------------------------------------
.text
.global __reset
__reset:
	mov #__SP_init,w15
	mov #__SPLIM_init,w0
	mov w0,_SPLIM
					; --- oscilator -----------------------
	mov	#0b0011001110000000,w0
	mov	w0,OSCCON
	mov	#0b0000000000000000,w0
	mov	w0,CLKDIV		; XT 8 MHz > 32 MHz
					; --- ADC -----------------------------
	mov	#0b1111111111111111,w0	; portovi digitalni
	mov	w0,AD1PCFG
					; --- PIN SELECT ----------------------
	mov	#0b0001010100010100,w0	; 21 na RP15 (OC4), 20 na RP14 (OC3)
	mov	w0,RPOR7
	mov	#0b0001001100010010,w0	; 19 na RP13 (OC2), 18na RP12 (OC1)
	mov	w0,RPOR6
	mov	#0b0000000000001001,w0	; 9 sa RP8 (U1RX)
	mov	w0,RPINR18
					; --- OUTPUT COMPARE ------------------

	mov	#0b0000000000000101,w0	; 101 = Continuous Pulse Mode
	mov	w0,OC1CON
	mov	w0,OC2CON
	mov	w0,OC3CON
	mov	w0,OC4CON
	mov	#0,w0			; permanent values for pulse start 
	mov	w0,OC1R
	mov	w0,OC2R
	mov	w0,OC3R
	mov	w0,OC4R
	mov	#2,w0
	mov	w0,OC1RS		; lo value for pulse end yellow
	mov	w0,OC2RS		; lo value for pulse end red
	mov	w0,OC3RS		; lo value for pulse end green
	mov	w0,OC4RS		; lo value for pulse end blue

					; --- TIMERS --------------------------
	mov	#0b1000000000000000,w0
	mov	w0,T2CON		; this timer needed for OC
	mov	#maxcount,w0		; timer period (T cycles)
	mov	w0,PR2
	mov	#maxcount-50,w0
	mov	w0,TMR2

	mov	#0b1000000000110000,w0	; prescaler bits 54 (11=256)
	mov	w0,T1CON		; timer for heartbeat interrupt
	mov	#1250,w0		; time period (1250=50Hz)
	mov	w0,PR1
					; --- UART (U1TXREG, U1RXREG) ---------
	mov	#0b0000100000001000,w0	; BRGH=1, UART disabled, RTS/CTS disabled
	mov	w0,U1MODE
	mov	#0b0010000000000000,w0
	mov	w0,U1STA
	mov	#416,w0			; 9600 Baud
	mov	w0,U1BRG
	bset	U1MODE,#15		; enable UART
	bset	U1STA,#UTXEN		; enable TX

					; --- PORTS ---------------------------
	clr	LATA
	clr	LATB
	clr	ODCA
	clr	ODCB

	mov	#0b0000000000000011,w0
	mov	w0,CNPU1		; pull-ups
	mov	#0b0000100001000000,w0
	mov	w0,CNPU2		; pull-ups
	bclr	RCON,#SWDTEN		; disable WDT

;------------------------------------------ RAM clear

	mov	#0x800,w1
	repeat	#128-1
	clr	[w1++]

	mov	#32,w0
	mov	w0,PATIENCEHI		; 32 x 41,96 = 1310 ms

	bset	INTCON1,#NSTDIS		; no interrupt nesting
	bclr	IFS0,#T1IF		; clr int flag
	bset	IEC0,#T1IE		; ENABLE INTERRUPT


;********************************************************************************
;****************************                       *****************************
;****************************        F A R M        *****************************
;****************************                       *****************************
;********************************************************************************


farm:
	clrwdt
	call	addr		; w13 adresa, 11111100 do 11111111

	call	receive		; prima header 101  **********
	mov.b	WREG,CHS
	sub	#101,w0
	cp0.b	w0
	bra	nz,farm

	call	receive		; prima adresu  **********
	add.b	CHS
	cp.b	w0,w13
	bra	nz,farm
				; moja adresa
	call	receive		; prima color 1  **********
	add.b	CHS
	call	calc_pwm
	mov	w0,PREPWM1	; yellow PWM

	call	receive		; prima color 2  **********
	add.b	CHS
	call	calc_pwm
	mov	w0,PREPWM2	; red PWM
 
	call	receive		; prima color 3  **********
	add.b	CHS
	call	calc_pwm
	mov	w0,PREPWM3	; green PWM

	call	receive		; prima color 4  **********
	add.b	CHS
	call	calc_pwm
	mov	w0,PREPWM4	; blue PWM

	call	receive		; prima jacinu  **********
	add.b	CHS
	call	calc_pwm3
	mov	w0,PREJACINA	; jacina

	call	receive		; prima chs  **********
	cp.b	CHS
	bra	nz,farm		; ne upisuje jer nije ispravan chs

	mov	PREPWM1,w0
	call	calc_pwm2
	mov	w0,TARGET1	; yellow PWM

	mov	PREPWM2,w0
	call	calc_pwm2
	mov	w0,TARGET2	; red PWM

	mov	PREPWM3,w0
	call	calc_pwm2
	mov	w0,TARGET3	; green PWM

	mov	PREPWM4,w0
	call	calc_pwm2
	mov	w0,TARGET4	; blue PWM

	call	trisports
	bset	FLAG,#1

	bra	farm

;________________________________
;________________________________ SUBS

calc_pwm:			; na ulazu: W0=LEDx (0...100)
	add	w0,w0,w0
	mov	#tblpage(tab1),w1
	mov	w1,TBLPAG
	mov	#tbloffset(tab1),w1
	add	w1,w0,w0
	tblrdl	[w0],w0		; na izlazu w0 = 0...490
	return

calc_pwm3:		; na ulazu: W0=LEDx (0...100)
	add	w0,w0,w0
	mov	#tblpage(tab2),w1
	mov	w1,TBLPAG
	mov	#tbloffset(tab2),w1
	add	w1,w0,w0
	tblrdl	[w0],w0		; na izlazu w0 = 0...490
	return

calc_pwm2:
	mov	PREJACINA,w1
	mul.uu	w0,w1,w2	; w2:w3 = 0 ... 240100
	mov	#4,w4
	repeat	#17
	div.ud	w2,w4		; na izlazu w0 = 0...20008
	inc	w0,w0		; da ne bude 0

;_______________

addr:				; na izlazu adresa u w13.b 11111100 do 11111111
	mov	#0b11111111,w13
	btss	dip2p,#dip2b
	bclr	w13,#2
	btss	dip3p,#dip3b
	bclr	w13,#1
	btss	dip4p,#dip4b
	bclr	w13,#0
	return

;------------------------

receive:			; \
	cp0	PATIENCEHI
	bra	z,1f

	dec	PATIENCELO	;   na svakih 625 ns
	btsc	SR,#Z
	dec	PATIENCEHI	;   na svakih 40,96 ms
	btsc	SR,#Z
	call	initris		;   samo ako nema nikakvog RX signala 300ms
1:
	btss	U1STA,#URXDA
	bra	receive		; / no byte received (10T = 625ns loop)

	clr	PATIENCELO
	clr	PATIENCEHI

	mov	#0,w0
	mov.b	U1RXREG,WREG
	return			; byte in w0

;_______________

initris:
	mov	#12000,w0
	mov	w0,OC1RS		; default value for pulse end yellow
	mov	w0,OC2RS		; default value for pulse end red
	mov	w0,OC3RS		; default value for pulse end green
	mov	#4000,w0
	mov	w0,OC4RS		; default value for pulse end blue
trisports:
	btsc	FLAG,#0
	return
	bset	FLAG,#0

	mov	#0b11111,w0
	mov	w0,TRISA
	mov	#0b0000001100110111,w0
	mov	w0,TRISB
	return

;***********************************************************************************
;****************************                          *****************************
;****************************    TIMER 1 INTERRUPT     *****************************
;****************************                          *****************************
;***********************************************************************************

.global __T1Interrupt
__T1Interrupt:			; TIMER1 interrupt
	push.s		; \

	btss	FLAG,#1
	bra	exit
;--------------------------------
	mov	#APPROACH1,w1
	mov	#TARGET1,w2
	call	polako
toonear1:
	mov	TMR2,w1
	sub	w0,w1,w2	; upis-tmr2-->w2
	add	#10,w2		; zabranjen opseg za w2 je 0...19
	cp	w2,#20
	bra	nc,toonear1
	cp	OC1RS
	btss	SR,#Z
	mov	w0,OC1RS	; yellow PWM
;--------------------------------
	mov	#APPROACH2,w1
	mov	#TARGET2,w2
	call	polako
toonear2:
	mov	TMR2,w1
	sub	w0,w1,w2	; upis-tmr2-->w2
	add	#10,w2		; zabranjen opseg za w2 je 0...19
	cp	w2,#20
	bra	nc,toonear2
	cp	OC2RS
	btss	SR,#Z
	mov	w0,OC2RS	; red PWM
;--------------------------------
	mov	#APPROACH3,w1
	mov	#TARGET3,w2
	call	polako
toonear3:
	mov	TMR2,w1
	sub	w0,w1,w2	; upis-tmr2-->w2
	add	#10,w2		; zabranjen opseg za w2 je 0...19
	cp	w2,#20
	bra	nc,toonear3
	cp	OC3RS
	btss	SR,#Z
	mov	w0,OC3RS	; green PWM
;--------------------------------
	mov	#APPROACH4,w1
	mov	#TARGET4,w2
	call	polako
toonear4:
	mov	TMR2,w1
	sub	w0,w1,w2	; upis-tmr2-->w2
	add	#10,w2		; zabranjen opseg za w2 je 0...19
	cp	w2,#20
	bra	nc,toonear4
	cp	OC4RS
	btss	SR,#Z
	mov	w0,OC4RS	; blue PWM
;--------------------------------
exit:
	pop.s		; /
	bclr	IFS0,#T1IF	; clr int flag
	retfie
;-------
polako:				; [w1] juri [w2], najgori slucaj 41T
	mov	#6000,w3	; step value 6

	mov	#9000,w0	; boundary 5
	cp	w1,w0
	btss	SR,#C
	mov	#1000,w3	; step value 5

	mov	#1000,w0	; boundary 4
	cp	w1,w0
	btss	SR,#C
	mov	#120,w3		; step value 4

	mov	#500,w0		; boundary 3
	cp	w1,w0
	btss	SR,#C
	mov	#8,w3		; step value 3

	mov	#200,w0		; boundary 2
	cp	w1,w0
	btss	SR,#C
	mov	#3,w3		; step value 2

	mov	#60,w0		; boundary 1
	cp	w1,w0
	btss	SR,#C
	mov	#1,w3		; step value 1

	mov	#20,w0		; boundary 0
	cp	w1,w0
	bra	c,gth20

	mov	[w1],w0
	inc	UNIFORM
	btss	UNIFORM,#0
	return

gth20:
	mov	[w1],w0
	cp	w0,[w2]		; approach-target
	btsc	SR,#Z
	return			; vrati se ako je approach=target
	bra	c,polakodec	; -
				; +
	mov	[w1],w0		; approach
	add	w0,w3,w0	; increase by one step
	cp	w0,[w2]		; approach-target
	bra	c,overflowed
	mov	w0,[w1]		; new approach
	return
overflowed:
	mov	[w2],w0		; target
	mov	w0,[w1]		; to approach
	return

polakodec:
	mov	[w1],w0		; approach
	sub	w0,w3,w0	; decrease by one step
	btsc	w0,#15
	bra	underflowed	; spec test, ako ce da padne ispod 0
	cp	w0,[w2]		; approach-target
	bra	nc,underflowed
	mov	w0,[w1]		; new approach
	return
underflowed:
	mov	[w2],w0		; target
	mov	w0,[w1]		; to approach
	return
;-------------------------------------------------------------------
tab1:				; tabela za linearizaciju hrominance
.word   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19
.word  20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39
.word  40, 42, 44, 46, 48, 50, 52, 54, 56, 58, 60, 62, 64, 66, 68, 70, 72, 74, 76, 78
.word  80, 82, 84, 86, 88, 90, 92, 94, 96, 98,100,103,109,112,115,118,121,124,127,130
.word 134,138,142,146,150,154,158,162,166,170,175,180,185,190,195,201,207,213,219,225
.word 231

;-------------------------------------------------------------------
tab2:				; tabela za linearizaciju luminance
.word   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19
.word  20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39
.word  40, 42, 44, 46, 48, 50, 52, 54, 56, 58, 60, 62, 64, 66, 68, 70, 72, 74, 76, 78
.word  81, 84, 87, 90, 93, 96, 99,102,105,109,113,117,121,125,129,133,138,143,148,153
.word 159,165,171,178,185,192,200,208,217,228,237,246,256,266,277,288,299,310,322,334
.word 346

;-------------------------------------------------------------------

 .end
 